/***************************************************************************
****************************************************************************
****************************************************************************
*
* Clobberd - By Jason Nunn
* Copyright (C) 1996,1997,1998 Jason Nunn
*
* Clobberd comes under the GNU General Public License. Please read the
* COPYING notice in this distribution.
*
* ================================================================
*
****************************************************************************
****************************************************************************
***************************************************************************/
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <signal.h>
#include <utmp.h>
#include <dirent.h>
#include <sys/types.h>
#include <sys/wait.h>
#include "defs.h"
#include "misc.h"
#include "log.h"
#include "sm.h"
#include "monitor.h"

int child_count = 0;

/***************************************************************************
*
***************************************************************************/
void nuke_zombies(void)
{  
  if(child_count > 0)
  {
    int s;
 
    if(waitpid(-1,&s,WNOHANG) > 0)
    {
      child_count--;
      log_msg('I',"Nuked zombie",0);
    }
  }
}

void inc_child_count(void)
{
  log_msg('I',"Created child",0); 
  child_count++;
}

/***************************************************************************
*
***************************************************************************/
void clobber_user(tum_ll *um)
{
  register int r;

  if(test_mode)
    return;

  r = fork();
  if(r == -1)
    perror("clobber_user() fork()");
  else
  {
    if(r == 0)     /*child*/
    {
      sprintf(argv_ptr[0],"clobberd -clobber %s",um->user);
      sleep(4);

#ifdef CLOBBER_LOGIN_PROCESSES_ONLY
      setutent();
      for(;;)
      {
        struct utmp *utmp_ptr;

        utmp_ptr = getutent();
        if(utmp_ptr == NULL)
          break;
        if(utmp_ptr->ut_type == USER_PROCESS)
          if(!strncmp(utmp_ptr->ut_user,um->user,UT_NAMESIZE))
            killpg(utmp_ptr->ut_pid,SIGHUP);
      }
      endutent();
#else
      {
        DIR *dp;
        struct dirent *dir_entry;
        struct stat statbuf;
        struct passwd *pw;
        char str[STR_LEN];

        pw = getpwnam(um->user);
        if(pw != NULL)
          if((dp = opendir("/proc")) != NULL)
          {
            while((dir_entry = readdir(dp)) != NULL)
            {
              int e_pid;

              if(sscanf(dir_entry->d_name,"%d",&e_pid))
              {
                strcpy(str,"/proc/");
                strcat(str,dir_entry->d_name);
                if((lstat(str,&statbuf) != -1) &&
                  (pw->pw_uid == statbuf.st_uid))
                  kill(e_pid,SIGHUP);
              }
            }
            closedir(dp);
          }
      }
#endif

      exit(0);
    }
    else
    {
      inc_child_count();
      um->no_active = 0;
      init_um(um);
    }
  }
}
