/***************************************************************************
****************************************************************************
****************************************************************************
*
* Clobberd - By Jason Nunn
* Copyright (C) 1996,1997,1998 Jason Nunn
*
* Clobberd comes under the GNU General Public License. Please read the
* COPYING notice in this distribution.
*
* ================================================================
* daemon logger
*
****************************************************************************
****************************************************************************
***************************************************************************/
#include <stdio.h>
#include <errno.h>
#include <sys/time.h>
#include "defs.h"
#include "misc.h"
#include "sm.h"
#include "monitor.h"

/***************************************************************************
* E: = error
* W: = Warning
* I: = Information
***************************************************************************/
void log_msg(char stat,char *msg,int srl)
{
  if(TUSF_HR_G_RUN_LEVEL(us_hr.flags) <= srl)
  {
    char str[STR_LEN];
    char *ct;

    ct = ctime((time_t *)&timer);
    if(ct)
      ct[strlen(ct) - 6] = 0;
    sprintf(str,"%s %c%1d: %s",ct,stat,srl,msg);
    if(daemon_mode)
    {
      FILE *fp;

      if((fp = fopen(LOG_FILE,"a")) != NULL)
      {
        fprintf(fp,"%s\n",str);
        fclose(fp);
      }
    }
    else
      printf("%s\n",str);
  }
}

void log_error(char *msg)
{
  char str[STR_LEN];

  sprintf(str,"%s: %s",msg,sys_errlist[errno]);
  log_msg('E',str,1);
}
