/***************************************************************************
* These routines are used to check for memory leaks..
*
* only used to test. not really a part of the release.
***************************************************************************/
#include <stdio.h>
#include <malloc.h>
#include "defs.h"
#include "log.h"

int mem_alloc;

void *nmalloc(size_t size)
{
  void *m;

  if((m = malloc(size + sizeof(size_t))) != NULL)
  {
    mem_alloc += size;
    *(size_t *)m = size;
    return m + sizeof(size_t);
  }
  return NULL;
}

void *nrealloc(void *m,size_t size)
{
  if(m == NULL)
    return nmalloc(size);
  m -= sizeof(size_t);
  mem_alloc -= *(size_t *)m;
  if((m = realloc(m,size + sizeof(size_t))) != NULL)
  {
    mem_alloc += size;
    *(size_t *)m = size;
    return m + sizeof(size_t);
  }
  return NULL;        
}

void nfree(void *ptr)
{
  void *m = ptr - sizeof(size_t);
  mem_alloc -= *(size_t *)m;
  free(m);
}

void print_nmem(void)
{
  printf("Memory alloc: %d bytes\n",mem_alloc);
}

void print_nmem_nothing(void)
{
  /*do sfa*/
}

void log_nmalloc(void)
{
  char str[STR_LEN];

  sprintf(str,"Malloc: %d bytes",mem_alloc);
  log_msg('I',str,1);
}
