/***************************************************************************
****************************************************************************
****************************************************************************
*
* Clobberd - By Jason Nunn
* Copyright (C) 1996,1997,1998 Jason Nunn
*
* Clobberd comes under the GNU General Public License. Please read the
* COPYING notice in this distribution.
*
* ================================================================
*
****************************************************************************
****************************************************************************
***************************************************************************/
extern "C" {
#include <curses.h>
#include "../clobberd/defs.h"
#include "../clobberd/misc.h"
}
#include "gui.h"
#include "misc.h"
#include "nclient.h"
#include "main_menu.h"

/***************************************************************************
*
***************************************************************************/
void main_app(void)
{
  notify_on(notify_label,"Connecting to Daemon, please wait...");
  client_s = client_bind_socket(addr,PORT);
  if(client_s)
  {
    client_fp = fdopen(client_s,"a+");
    if(client_fp != NULL)
    {
      if(net_get_ok() == 2)
      {
        tmain_menu main_menu;
        tstrbox strbox;
        char passwd[STR_GEN_LEN + 1];

        display_topbar();
        main_menu.create();
        for(;;)
        {
          register int s;
          char str[STR_LEN_LN];

          passwd[0] = 0;
          strbox.create("Enter Password (or 'quit' to quit)",
            3,STR_GEN_LEN,6,20,STR_GEN_LEN);
          strbox.run(passwd);
          strbox.dest();
          if(!strcmp(passwd,"quit"))
            break;
          notify_on(notify_label,pwait_mess);
          sprintf(str,"%s %s",cmd_pass,passwd);
          net_put_cmd(str);
          s = net_get_ok();
          notify_off();
          if(s == 1)
            notify(error_label,"Password incorrect. Try again.");
          else if(s == 2)
          {
            main_menu.run();
            break;
          }
        }
        main_menu.dest();
        net_put_cmd(cmd_quit);
      }
      if(client_fp != NULL)
        fclose(client_fp);
    }
    close_socket(client_s);
  }
  else
  {
    notify_off();
    notify(error_label,ddown_mess);
  }
}

/***************************************************************************
*
***************************************************************************/
int main(int argc,char *argv[])
{
  printf(WELCOME);
  if(argc != 2)
  {
    printf(
      "Usage: clobberedit <address>\n"
      "\n");
    return -1;
  }
  if(argc == 2)
    addr = argv[1];
  else
  {
    printf("Error: Missing parameters, Aborting.\n");
    return -1;
  }
  client_init();
  initscr();
  start_color();
  init_colour_pairs();
  cbreak();
  noecho();
  keypad(stdscr,TRUE);
  main_app();
  clear();
  refresh();
  resetterm();
  echo();
  endwin();
  return 0;
}
