/***************************************************************************
****************************************************************************
****************************************************************************
*
* Clobberd - By Jason Nunn
* Copyright (C) 1996,1997,1998 Jason Nunn
*
* Clobberd comes under the GNU General Public License. Please read the
* COPYING notice in this distribution.
*
* ================================================================
*
****************************************************************************
****************************************************************************
***************************************************************************/
extern "C" {
#include <curses.h>
#include <sys/time.h>
#include "../clobberd/nmalloc.h"
#include "../clobberd/defs.h"
#include "../clobberd/misc.h"
}
#include "gui.h"
#include "misc.h"
#include "nclient.h"

#include "kon_stat_obj.h"

/***************************************************************************
* connection stats
***************************************************************************/
tkon_stat::tkon_stat(void)
{
  kon_list = NULL;
}

tkon_stat::~tkon_stat(void)
{
  if(kon_list != NULL)
    delete(kon_list);
}

int tkon_stat::get_stats(void)
{
  if(kon_list != NULL)
    delete(kon_list);
  kon_list = new(tscroll_select);
  if(kon_list != NULL)
  {
    kon_list->init(pos_y + 2,pos_x + 1,17,53,1);
    notify_on(notify_label,pwait_mess);
    net_put_cmd(cmd_stat);
    for(;;)
    {
      char str[STR_LEN_LN + 1];

      if(!net_get_entry(str))
        return 0;
      if(!strcmp(str,cmd_er))
        return 1;
      if(!strcmp(str,cmd_ok))
        break;
      if(str[0] == ':')
        kon_list->append(str + 1);
    }
  }
  else
    return 0;
  return 1;
}

int tkon_stat::create(void)
{
  tdialog::create(
    "Current Connections",
    20,56,2,1,
    COLOR_PAIR(4) | A_BOLD);
  if(!get_stats())
  {
    notify_off();
    return 0;
  }
  tobj::create(this);
  return 1;
}

void tkon_stat::redraw(void)
{
  time_t t;
  char *str_ptr;

  tdialog::redraw();
  t = time(NULL);
  str_ptr = ctime(&t);
  if(str_ptr != NULL)
  {
    addch(' ');
    addnstr(str_ptr + 11,8);
  }
  attrset(COLOR_PAIR(5) | A_BOLD);
  move(pos_y + 1,pos_x + 1);
  addstr("Host");
  move(pos_y + 1,pos_x + 44);
  addstr("Port");
  kon_list->redraw();
}

void tkon_stat::run(void)
{
  while(running)
  {
    ch = getch();
    switch(ch)
    {
      case 'Q':
        running = 0;
        break;
      case KEY_UP:
        kon_list->cursor_up();
        update();
        break;
      case KEY_DOWN:
        kon_list->cursor_down();
        update();
        break;
      case ' ':
        if(get_stats())
        {
          redraw();
          update();
        }
        else
          running = 0;
        break;
    }
  }
}
