/***************************************************************************
****************************************************************************
****************************************************************************
*
* Clobberd - By Jason Nunn
* Copyright (C) 1996,1997,1998 Jason Nunn
*
* Clobberd comes under the GNU General Public License. Please read the
* COPYING notice in this distribution.
*
* ================================================================
*
****************************************************************************
****************************************************************************
***************************************************************************/
extern "C" {
#include <curses.h>
#include <string.h>
#include "../clobberd/nmalloc.h"
#include "../clobberd/defs.h"
#include "../clobberd/misc.h"
}
#include "gui.h"
#include "misc.h"
#include "nclient.h"
#include "dt.h"

#include "us_obj.h"

/***************************************************************************
* Edit def User Settings
***************************************************************************/
tedit_def_us::tedit_def_us(void)
{
}

tedit_def_us::~tedit_def_us(void)
{
}

void tedit_def_us::set_notify_email(int index)
{
  if(curr_us->flags & TUSF_NOTIFY_VIA_EMAIL)
  {
    sprintf(str,"%s",curr_us->email);
    if(strlen(str) > 13) str[12] = '+';  
    str[13] = 0;
    us_select.ammend_str(index,27,str);
  }
  else
    us_select.ammend_str(index,27,"tty");
}

void tedit_def_us::set_tt(int index)
{
  if(curr_us->flags & TUSF_EXPT_TOTAL_TIME)
    us_select.ammend_str(index,27,exempt_label);
  else
  {
    str_hh_mm(curr_us->tt_lim,str);
    us_select.ammend_str(index,27,str);
  }
}

void tedit_def_us::set_dt(int index)
{
  if(curr_us->flags & TUSF_EXPT_DAILY_TIME)
    us_select.ammend_str(index,27,exempt_label);
  else
    us_select.ammend_str(index,27,"");
}

void tedit_def_us::set_expiry_date(int index) //dd:mm:yyyy
{
  if(curr_us->flags & TUSF_EXPT_EXPIRY_DATE)
    us_select.ammend_str(index,27,exempt_label);
  else
  {
    compose_date(&(curr_us->expiry_date),str);
    us_select.ammend_str(index,27,str);
  }
}

void tedit_def_us::set_niceness(int index)
{
  if(curr_us->flags & TUSF_EXPT_NICE)
    us_select.ammend_str(index,27,exempt_label);
  else
  {
    sprintf(str,"%d",curr_us->nice_factor);
    us_select.ammend_str(index,27,str);
  }
}

void tedit_def_us::set_tul(int index)
{
  if(curr_us->flags & TUSF_EXPT_TOTAL_UL_LIM)
    us_select.ammend_str(index,27,exempt_label);
  else
  {
    sprintf(str,"%d",curr_us->t_ul_lim);
    us_select.ammend_str(index,27,str);
  }
}

void tedit_def_us::set_tdl(int index)
{
  if(curr_us->flags & TUSF_EXPT_TOTAL_DL_LIM)
    us_select.ammend_str(index,27,exempt_label);
  else
  {
    sprintf(str,"%d",curr_us->t_dl_lim);
    us_select.ammend_str(index,27,str);
  }
}

void tedit_def_us::set_dul(int index)
{
  if(curr_us->flags & TUSF_EXPT_DAILY_UL_LIM)
    us_select.ammend_str(index,27,exempt_label);
  else
  {
    sprintf(str,"%d",curr_us->d_ul_lim);
    us_select.ammend_str(index,27,str);
  }
}

void tedit_def_us::set_ddl(int index)
{
  if(curr_us->flags & TUSF_EXPT_DAILY_DL_LIM)
    us_select.ammend_str(index,27,exempt_label);
  else
  {
    sprintf(str,"%d",curr_us->d_dl_lim);
    us_select.ammend_str(index,27,str);
  }
}

void tedit_def_us::set_purge_dt(int index)
{
  us_select.ammend_str(index,27,
    curr_us->flags & TUSF_INSTANT_PURGE_DT ? yes_label : no_label);
}

void tedit_def_us::set_clob_mult_logins(int index)
{
  us_select.ammend_str(index,27,
    curr_us->flags & TUSF_CLOBBER_MULT_LOGINS ? yes_label : no_label);
}

void tedit_def_us::set_clobber(int index)
{
  us_select.ammend_str(index,27,
    curr_us->flags & TUSF_CLOBBER ? yes_label : no_label);
}

void tedit_def_us::set_act_to(int index)
{
  if(curr_us->flags & TUSF_EXPT_ACT_TIMEOUT)
    us_select.ammend_str(index,27,exempt_label);
  else
  {   
    str_hh_mm(curr_us->act_timeout,str);
    us_select.ammend_str(index,27,str);
  }
}

void tedit_def_us::create(tus_ll *usp,char *hr,int y,int x)
{
  curr_us = usp;
  tdialog::create(hr,15,42,y,x,COLOR_PAIR(4) | A_BOLD);
  us_select.init(pos_y + 1,pos_x + 1,13,40,0);

  us_select.append("Email Address            : xxxxxxxxxxxxx");
  us_select.append("Total Time Limit (hhh:mm): xxxxxx");
  us_select.append("Daily Time Limits        > xxxxxx");
  us_select.append("Expiry Date (dd:mm:yyyy) : dd:mm:yyyy");
  us_select.append("Niceness                 : dddddddddd");
  us_select.append("Total Upload Limit   (Mb): dddddddddd");
  us_select.append("Total Download Limit (Mb): dddddddddd");
  us_select.append("Daily Upload Limit   (Mb): dddddddddd");
  us_select.append("Daily Download Limit (Mb): dddddddddd");
  us_select.append("Reset DT after Clobber   : xxx");
  us_select.append("Clobber multiple Dialins : xxx");
  us_select.append("Permanently Ban User     : xxx");
  us_select.append("Activity Timeout (hhh:mm): xxx:xx");

  set_notify_email(0);
  set_tt(1);
  set_dt(2);
  set_expiry_date(3);
  set_niceness(4);
  set_tul(5);
  set_tdl(6);
  set_dul(7);
  set_ddl(8);
  set_purge_dt(9);
  set_clob_mult_logins(10);
  set_clobber(11);
  set_act_to(12);
  tobj::create(this);
}

void tedit_def_us::redraw(void)
{
  tdialog::redraw();
  attrset(COLOR_PAIR(5));
  us_select.redraw();
}

void tedit_def_us::open_dt(void)
{
  if(!(curr_us->flags & TUSF_EXPT_DAILY_TIME))
  {
    tedit_dt edit_dt;

    edit_dt.create(curr_us->dt_lim);
    edit_dt.run();
    edit_dt.dest();
    if(edit_dt.touched)
      touched = 1;
  }
}

void tedit_def_us::run_selections(void)
{
  switch(us_select.get_option())
  {
    case 0: // edit email
      if(curr_us->flags & TUSF_NOTIFY_VIA_EMAIL)
      {
        touched = 1;
        us_select.get_string(curr_us->email,27,STR_LEN_LN,13);
        set_notify_email(0);
do_redraw:
        us_select.redraw();
        update();
      }
      break;
    case 1: // get total time
      if(!(curr_us->flags & TUSF_EXPT_TOTAL_TIME))
      {
        touched = 1;
        curr_us->tt_lim = us_select.get_hr_min(27);
        range_check(&(curr_us->tt_lim),0,999 * 60 * 60);
        set_tt(1);
        goto do_redraw;
      }
      break;
    case 2: // Daily Time Limits
      open_dt();
      break;
    case 3: // Get Expiry Date
      if(!(curr_us->flags & TUSF_EXPT_EXPIRY_DATE))
      {
        int x,y;

        touched = 1;
        str[0] = 0;
        us_select.get_string(str,27,10,10);
        sscanf(str,"%d:%d:%d",&x,&y,&(curr_us->expiry_date.year));
        range_check(&x,1,31);
        range_check(&y,1,12);
        range_check(&(curr_us->expiry_date.year),1970,9999);
        curr_us->expiry_date.day = (char)x;
        curr_us->expiry_date.month = (char)y;
        set_expiry_date(3);
        goto do_redraw;
      }
      break;
    case 4: // Get niceness
      if(!(curr_us->flags & TUSF_EXPT_NICE))
      {
        touched = 1;
        curr_us->nice_factor = us_select.get_integer(27);
        range_check(&(curr_us->nice_factor),-20,20);
        set_niceness(4);
        goto do_redraw;
      }
      break;
    case 5: // tul
      if(!(curr_us->flags & TUSF_EXPT_TOTAL_UL_LIM))
      {
        touched = 1;
        curr_us->t_ul_lim = us_select.get_integer(27);
        set_tul(5);
        goto do_redraw;
      }
      break;
    case 6: // tdl
      if(!(curr_us->flags & TUSF_EXPT_TOTAL_DL_LIM))
      {
        touched = 1;
        curr_us->t_dl_lim = us_select.get_integer(27);
        set_tdl(6);
        goto do_redraw;
      }
      break;
    case 7: // dul
      if(!(curr_us->flags & TUSF_EXPT_DAILY_UL_LIM))
      {
        touched = 1;
        curr_us->d_ul_lim = us_select.get_integer(27);
        set_dul(7);
        goto do_redraw;
      }
      break;
    case 8: // ddl
      if(!(curr_us->flags & TUSF_EXPT_DAILY_DL_LIM))
      {
        touched = 1;
        curr_us->d_dl_lim = us_select.get_integer(27);
        set_ddl(8);
        goto do_redraw;
      }
      break;
    case 9: // toggle purge td on clobber
      touched = 1;
      curr_us->flags ^= TUSF_INSTANT_PURGE_DT;
      set_purge_dt(9);
      goto do_redraw;
    case 10: // toggle clob mult logins
      touched = 1;
      curr_us->flags ^= TUSF_CLOBBER_MULT_LOGINS;
      set_clob_mult_logins(10);
      goto do_redraw;
    case 11: //toggle clobber flag
      touched = 1;
      curr_us->flags ^= TUSF_CLOBBER;
      set_clobber(11);
      goto do_redraw;
    case 12:
      if(!(curr_us->flags & TUSF_EXPT_ACT_TIMEOUT))
      {
        touched = 1;
        curr_us->act_timeout = us_select.get_hr_min(27);
        range_check(&(curr_us->act_timeout),0,999 * 60 * 60);
        set_act_to(12);
        goto do_redraw;
      }
      break;
  }
}

void tedit_def_us::toggle_exemptions(void)
{
  touched = 1;
  switch(us_select.get_option())
  {
    case 0:
      curr_us->flags ^= TUSF_NOTIFY_VIA_EMAIL;
      set_notify_email(0);
      goto do_redraw;
    case 1:
      curr_us->flags ^= TUSF_EXPT_TOTAL_TIME;
      set_tt(1);
      goto do_redraw;
    case 2:
      curr_us->flags ^= TUSF_EXPT_DAILY_TIME;
      set_dt(2);
      goto do_redraw;
    case 3:
      curr_us->flags ^= TUSF_EXPT_EXPIRY_DATE;
      set_expiry_date(3);
      goto do_redraw;
    case 4:
      curr_us->flags ^= TUSF_EXPT_NICE;
      set_niceness(4);
      goto do_redraw;
    case 5:
      curr_us->flags ^= TUSF_EXPT_TOTAL_UL_LIM;
      set_tul(5);
      goto do_redraw;
    case 6:
      curr_us->flags ^= TUSF_EXPT_TOTAL_DL_LIM;
      set_tdl(6);
      goto do_redraw;
    case 7:
      curr_us->flags ^= TUSF_EXPT_DAILY_UL_LIM;
      set_dul(7);
      goto do_redraw;
    case 8:
      curr_us->flags ^= TUSF_EXPT_DAILY_DL_LIM;
      set_ddl(8);
do_redraw:
      us_select.redraw();
      update();
      break;
    case 12:
      curr_us->flags ^= TUSF_EXPT_ACT_TIMEOUT;
      set_act_to(12);
      goto do_redraw;
  }
}

void tedit_def_us::run(void)
{
  while(running)
  {
    ch = getch();
    switch(ch)
    {
      case 'Q':
        running = 0;
        break;
      case KEY_UP:
        us_select.cursor_up();
        update();
        break;
      case KEY_DOWN:
        us_select.cursor_down();
        update();
        break;
      case 'E':
        toggle_exemptions();
        break;
      case 10:
        run_selections();
        break;
    }
  }
}

/***************************************************************************
* Edit User Settings
***************************************************************************/
tedit_us::tedit_us(void)
{
  user_list = NULL;
}

tedit_us::~tedit_us(void)
{
  if(user_list != NULL)
    delete(user_list);
}

int tedit_us::get_users(char *cmd)
{
  if(user_list != NULL) //this is here so list can be reloaded
    delete(user_list);
  user_list = new(tscroll_select);
  if(user_list != NULL)
  {
    user_list->init(pos_y + 1,pos_x + 1,length,STR_USER_LEN,1);
    net_put_cmd(cmd);
    for(;;)
    {
      char str[STR_LEN_LN + 1];

      if(!net_get_entry(str))
        return 0;
      if(!strcmp(str,cmd_er))
        return 1;
      if(!strcmp(str,cmd_ok))
        break;
      if(str[0] == ':')
        user_list->append(str + 1);
    }
  }
  else
    return 0;
  return 1;
}

int tedit_us::create(void)
{
  tdialog::create(
    "US",
    19,STR_USER_LEN + 3,3,3,
    COLOR_PAIR(4) | A_BOLD);
  length = 17;
  notify_on(notify_label,pwait_mess);
  if(!get_users(cmd_gusu))
  {
    notify_off();
    return 0;
  }
  tobj::create(this);
  return 1;
}

void tedit_us::redraw(void)
{
  tdialog::redraw();
  attrset(COLOR_PAIR(5));
  user_list->redraw();
}

void tedit_us::get_users2(void)
{
  notify_on(notify_label,pwait_mess);
  if(get_users(cmd_gusu))
  {
    redraw();
    update();
  }
  else
    running = 0;
  notify_off();
}

void tedit_us::select(void)
{
  char *user;

  notify_on(notify_label,pwait_mess);
  user_list->get_str(user_list->get_option(),0,&user);
  if(net_lock_user(user) == 2)
  {
    tedit_def_us edit_us_entry;

    if(net_get_us(user,0) == 2)
    {
      edit_us_entry.create(&us,"User Settings",3,15);
      edit_us_entry.run();
      edit_us_entry.dest();
      notify_on(notify_label,pwait_mess);
      if(edit_us_entry.touched)
        net_put_us();
    }
    else
      notify(error_label,"Error loading US");
    net_unlock_user();
  }
  notify_off();
}

void tedit_us::add_user(void)
{
  tstrbox strbox;
  tedit_def_us edit_us;
  char user[STR_USER_LEN + 1] = "";

  strbox.create("New User",
    3,STR_USER_LEN,pos_y + 1,pos_x + 2,STR_USER_LEN);
  strbox.run(user);
  strbox.dest();
  if(user[0] == 0)
  {
    notify(error_label,"Bad Username.");
    return;
  }
  notify_on(notify_label,pwait_mess);
  if(net_new_us(user) == 2)
  {
    if(net_get_us_hr() == 2)
    {
      memcpy(&us,&(us_hr.default_us),TUS_LL_SIZE);
      strcpy(us.user,user);
      edit_us.create(&us,"User Settings",3,15);
      edit_us.run();
      edit_us.dest();
      notify_on(notify_label,pwait_mess);
      if(net_put_us() == 2)
        if(get_users(cmd_gusu))
        {
          user_list->goto_user(user);
          redraw();
          update();
        }
    }
    net_unlock_user();
  }
  notify_off();
}

void tedit_us::delete_user(void)
{
  char *user;
  int tmp_pos,tmp_hl;

  tmp_pos = user_list->pos;
  tmp_hl = user_list->hl;
  user_list->get_str(user_list->get_option(),0,&user);
  notify_on(notify_label,pwait_mess);
  if(net_lock_user(user) == 2)
  {
    if(net_delete_us(user) == 2)
      if(get_users(cmd_gusu))
      {
        user_list->pos = tmp_pos;
        user_list->hl = tmp_hl;
        if(user_list->get_option() == user_list->list_size)
          user_list->cursor_up();
        redraw();
        update();
      }
    net_unlock_user();
  }
  notify_off();
}

void tedit_us::user_search(void)
{
  tstrbox u_search;
  char user[STR_USER_LEN + 1] = "";

  u_search.create("Find User",
    3,STR_USER_LEN,pos_y + 1,pos_x + 2,STR_USER_LEN);
  u_search.run(user);
  u_search.dest();
  user_list->goto_user(user);
  update();
}

void tedit_us::run(void)
{
  while(running)
  {
    ch = getch();

    switch(ch)
    {
      case 'Q':
        running = 0;
        break;
      case ' ':
        get_users2();
        break;
      case 'A':
        add_user();
        break;
      default:
        if(user_list->list_size)
          switch(ch)
          {
            case KEY_UP:
              user_list->cursor_up();
              update();
              break;
            case KEY_DOWN:
              user_list->cursor_down();
              update();
              break;
            case PAGE_UP:
              user_list->page_up();
              update();
              break;
            case PAGE_DOWN:
              user_list->page_down();
              update();
              break;
            case 10:
              select();
              break;
            case 'D':
              delete_user();
              break;
            case 'S':
              user_search();
              break;
          }
        break;
    }
  }
}
